<?php

/**
 * Myriad player mambot (for use with Joomla 1.0+)
 * @by Philippe Dejean dejean.philippe.free.fr
 * @copyright (C) 2007 
 * @version 0.1
 */

// no direct access
defined('_VALID_MOS') or die('Direct Access to this location is not allowed.');

/**
** Usage:
* <code>{myrmus}fichier.mus[:<parametre>]*{/myrmus}
* avec <parametre>::=<tag>=<valeur>
* 
*Les tags sont ceux du plugin :
*	width
*	height
*	docinfo
*	quality
*	autoplay
*	sing
*	menu
*	look
*	transp
*	displaysize
*	tempo
*	save
*	zoomvalue
*	change_volume
*	fullscreen
*	lang
*	lyrics
*/

$_MAMBOTS->registerFunction('onPrepareContent', 'botMyriadPlayer');

/** check, if already loaded. it could have been loaded by an external call */
if (!function_exists('botMyriadPlayer'))
{

/**
 *   Fonction principale
 */
function botMyriadPlayer($published, &$row, &$params, $page = 0) {
	global $database, $mosConfig_live_site, $_MAMBOTS;

	$regex = "#{myrmus}(.*?){/myrmus}#s";
	if (!$published) {
		$row->text = preg_replace( $regex, '', $row->text );
		return;
		}
	$row->text = preg_replace_callback( $regex, 'botMyriadPlayer_replacer', $row->text );
	return true;
	}

/**
* @param array An array of matches
* @return string
*/
function botMyriadPlayer_replacer ( &$matches )
{
	global $mosConfig_live_site,$mosConfig_absolute_path, $mosConfig_lang, $database;

	$res = $matches[1];

	$query = "SELECT id FROM #__mambots WHERE element = 'myriad' AND folder = 'content'";
	$database->setQuery( $query );
	$id = $database->loadResult();
	$mambot = new mosMambot( $database );
	$mambot->load( $id );
	$params =& new mosParameters( $mambot->params );

	$separateur	= ':';
	$border		= '0';
	$width		= $params->get( 'width', '630' );
	$height		= $params->get( 'height', '891' );
	$docinfo	= $params->get( 'docinfo', 'off' );
	$quality	= $params->get( 'quality', 'high' );
	$autoplay	= $params->get( 'autoplay', 'off' );
	$sing		= $params->get( 'sing', 'off' );
	$menu		= $params->get( 'menu', 'on' );
	$look		= $params->get( 'look', 'shadow' );
	$transp		= $params->get( 'transp', 'off' );
	$displaysize	= $params->get( 'displaysize', 'off' );
	$tempo		= $params->get( 'tempo', 'off' );
	$save		= $params->get( 'save', 'off' );
	$zoomvalue	= $params->get( 'zoomvalue', '100' );
	$change_volume	= $params->get( 'change_volume', 'on' );
	$fullscreen	= $params->get( 'fullscreen','off' );
	$lang		= $params->get( 'lang', 'fr' );
	$lyrics		= $params->get( 'lyrics', 'off' );

	$var = explode( $separateur, $res );
	$nbparam = count( $var );
	$path=$path."/";

	if ( $nbparam == 1 )
	{
		$musique=$res;
	}
	else
	{
		$musique=$var[0];
		for ( $i=1; $i<=$nbparam; $i++ )
		{
			$parametre = explode( "=", $var[$i] );

			$champ = strpos (  $parametre[0], "width" );
			if (!($champ===false))
			{
				$width=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "height" );
			if (!($champ===false))
			{
				$height=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "quality" );
			if (!($champ===false))
			{
				$quality=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "docinfo" );
			if (!($champ===false))
			{
				$docinfo=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "autoplay" );
			if (!($champ===false))
			{
				$autoplay=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "sing" );
			if (!($champ===false))
			{
				$sing=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "displaysize" );
			if (!($champ===false))
			{
				$displaysize=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "menu" );
			if (!($champ===false))
			{
				$menu=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "transp" );
			if (!($champ===false))
			{
				$transp=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "tempo" );
			if (!($champ===false))
			{
				$tempo=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "save" );
			if (!($champ===false))
			{
				$save=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "change_volume" );
			if (!($champ===false))
			{
				$change_volume=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "fullscreen" );
			if (!($champ===false))
			{
				$fullscreen=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "lang" );
			if (!($champ===false))
			{
				$lang=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "lyrics" );
			if (!($champ===false))
			{
				$lyrics=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "look" );
			if (!($champ===false))
			{
				$look=$parametre[1];
			}
			$champ = strpos (  $parametre[0], "look" );
			if (!($champ===false))
			{
				$zoomvalue=$parametre[1];
			}
		}
	}

	if( file_exists( $mosConfig_absolute_path."/".$musique ) )
	{
		$musique="/".$musique;
	}
	else
	{
		$musique="";
	}

	$res = '</br><object classid="CLSID:07000E2B-6AAD-497D-8E5B-5976560AD429"
border="'.$border.'"
width="'.$width.'"
height="'.$height.'">
<param name="src" value="'.$musique.'" />
<param name="width" value="'.$width.'" />
<param name="height" value="'.$height.'" />
<param name="quality" value="'.$quality.'" />
<param name="docinfo" value="'.$docinfo.'" />
<param name="autoplay" value="'.$autoplay.'" />
<param name="sing" value="'.$sing.'" />
<param name="displaysize" value="'.$displaysize.'" />
<param name="menu" value="'.$menu.'" />
<param name="transp" value="'.$transp.'" />
<param name="tempo" value="'.$tempo.'" />
<param name="save" value="'.$save.'" />
<param name="zoomvalue" value="'.$zoomvalue.'" />
<param name="change_volume" value="'.$change_volume.'" />
<param name="fullscreen" value="'.$fullscreen.'" />
<param name="lang" value="'.$lang.'" />
<param name="lyrics" value="'.$lyrics.'" />
<param name="look" value="'.$look.'" />
<param name="type" value="application/x-myriad-music" />
<param name="pluginspage" value="http://www.myriad-online.com/cgi-bin/mmplug.pl?lang=fr" />
<embed src="'.$musique.'"
width='.$width.'
height='.$height.'
quality='.$quality.'
docinfo='.$docinfo.'
autoplay='.$autoplay.'
sing='.$sing.'
displaysize='.$displaysize.'
menu='.$menu.'
transp='.$transp.'
tempo='.$tempo.'
save='.$save.'
zoomvalue='.$zoomvalue.'
change_volume='.$change_volume.'
fullscreen='.$fullscreen.'
lang='.$lang.'
lyrics='.$lyrics.'
look='.$look.'
type="application/x-myriad-music"
pluginspage="http://www.myriad-online.com/cgi-bin/mmplug.pl?lang=fr">
</embed>
</object>';
	return $res;
}
} // end of if (!function_exists('botMyriadPlayer'))

?>
